# Sample Python code to convert list of PCRE to ANML file
# Kevin Angstadt
# angstadt {at} virginia.edu

import argparse, os
from micronap.sdk import *

def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("pcre_file", help="the pcre file")
    parser.add_argument("outfile", help="the anml file")
    
    args = parser.parse_args()
    
    # strip the name
    name = os.path.splitext(os.path.split(args.outfile)[1])[0]
    
    # make the ANML workspace
    A = Anml()
    AN = A.CreateAutomataNetwork(anmlId=name)
    
    # open the regex file
    f = open(args.pcre_file, 'r')
    regex = f.readlines()
    f.close
    
    #use this to keep track of the pcre rule
    i = 0
    for r in regex:
        i += 1
        id = "_" + str(i)
        
        # get rid of whitespace
        r = r.strip()
        
        try:
            AN.AddRegex(r,
                        startType=AnmlDefs.ALL_INPUT,
                        reportCode=i,
                        anmlId=id,
                        match=True
                        )
        except ApError as e:
            print "error:", e, r
    
    AN.ExportAnml(args.outfile)

if __name__ == '__main__':
    main()